/* cl_nn.h
 * ANDHILL (soccer client for Robocup97)
 * Tomohito Andou <andou@is.titech.ac.jp>
 * Tokyo Institute of Technology
 * Dept of Mathematical and Computing Sciences
 * Copyright (C) 1997 Tomohito Andou
 */

#ifndef CL_NN_H
#define CL_NN_H

#include "client.h"

#define PA_IN	(5)
#define PA_HD	(5)
#define PA_OU	(1)

#define PO_IN	(3)
#define PO_OU	(1)
#define PO_SET	(SMALL_X*SMALL_Y)

extern double pa_i[PA_IN+1];
extern double pa_o[PA_OU];

extern double po_i[PO_SET][PO_IN+1];
extern double po_o[PO_SET][PO_OU];
extern double po_osum;
extern double po_io[PO_SET][PO_OU][PO_IN+1];

double pass_exec(void);
double posi_exec(void);
void posi_backprop(int selected);
void posi_init(void);
void posi_reward(double rew);
void posi_rand_init(void);
void posi_output(FILE* fp);
void posi_input(FILE* fp);
double sigmoid(double x);

#endif

/* End Of File */
